diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-extension.cc ns-3.47/src/internet/model/ipv6-extension.cc
--- ns-3.46/src/internet/model/ipv6-extension.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-extension.cc	2026-02-16 16:08:49.615229800 -0800
@@ -392,7 +392,7 @@
     Ipv6Address src = ipv6Header.GetSource();
 
     FragmentKey_t fragmentKey = FragmentKey_t(src, identification);
-    Ptr<Fragments> fragments;
+    std::shared_ptr<Fragments> fragments;
 
     Ipv6Header ipHeader = ipv6Header;
     ipHeader.SetNextHeader(fragmentHeader.GetNextHeader());
@@ -400,7 +400,7 @@
     auto it = m_fragments.find(fragmentKey);
     if (it == m_fragments.end())
     {
-        fragments = Create<Fragments>();
+        fragments = std::make_shared<Fragments>();
         m_fragments.insert(std::make_pair(fragmentKey, fragments));
         NS_LOG_DEBUG("Insert new fragment key: src: "
                      << src << " IP hdr id " << identification << " m_fragments.size() "
@@ -630,13 +630,12 @@
 Ipv6ExtensionFragment::HandleFragmentsTimeout(FragmentKey_t fragmentKey, Ipv6Header ipHeader)
 {
     NS_LOG_FUNCTION(this << fragmentKey.first << fragmentKey.second << ipHeader);
-    Ptr<Fragments> fragments;
 
     auto it = m_fragments.find(fragmentKey);
     NS_ASSERT_MSG(it != m_fragments.end(),
                   "IPv6 Fragment timeout reached for non-existent fragment");
-    fragments = it->second;
 
+    std::shared_ptr<Fragments> fragments = it->second;
     Ptr<Packet> packet = fragments->GetPartialPacket();
 
     // if we have at least 8 bytes, we can send an ICMP.
@@ -1026,6 +1025,17 @@
     m_extensionsRouting.remove(extensionRouting);
 }
 
+int64_t
+Ipv6ExtensionRoutingDemux::AssignStreams(int64_t stream)
+{
+    int64_t currentStream = stream;
+    for (auto& extension : m_extensionsRouting)
+    {
+        currentStream += extension->AssignStreams(currentStream);
+    }
+    return currentStream - stream;
+}
+
 NS_OBJECT_ENSURE_REGISTERED(Ipv6ExtensionLooseRouting);
 
 TypeId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-extension-demux.cc ns-3.47/src/internet/model/ipv6-extension-demux.cc
--- ns-3.46/src/internet/model/ipv6-extension-demux.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-extension-demux.cc	2026-02-16 16:08:49.615229800 -0800
@@ -88,4 +88,14 @@
     m_extensions.remove(extension);
 }
 
+int64_t
+Ipv6ExtensionDemux::AssignStreams(int64_t stream)
+{
+    int64_t currentStream = stream;
+    for (auto& extension : m_extensions)
+    {
+        currentStream += extension->AssignStreams(currentStream);
+    }
+    return currentStream - stream;
+}
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-extension-demux.h ns-3.47/src/internet/model/ipv6-extension-demux.h
--- ns-3.46/src/internet/model/ipv6-extension-demux.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-extension-demux.h	2026-02-16 16:08:49.615229800 -0800
@@ -69,6 +69,14 @@
      */
     void Remove(Ptr<Ipv6Extension> extension);
 
+    /**
+     * Assigns stream numbers to the registered extensions of this IPv6 demux object
+     *
+     * @param stream the first stream number to assign
+     * @returns the number of assigned streams
+     */
+    int64_t AssignStreams(int64_t stream);
+
   protected:
     /**
      * @brief Dispose object.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-extension.h ns-3.47/src/internet/model/ipv6-extension.h
--- ns-3.46/src/internet/model/ipv6-extension.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-extension.h	2026-02-16 16:08:49.615229800 -0800
@@ -330,7 +330,7 @@
      *
      * @brief This class stores the fragments of a packet waiting to be rebuilt.
      */
-    class Fragments : public SimpleRefCount<Fragments>
+    class Fragments
     {
       public:
         /**
@@ -436,7 +436,7 @@
     /**
      * @brief Container for the packet fragments.
      */
-    typedef std::map<FragmentKey_t, Ptr<Fragments>> MapFragments_t;
+    typedef std::map<FragmentKey_t, std::shared_ptr<Fragments>> MapFragments_t;
 
     /**
      * @brief The hash of fragmented packets.
@@ -579,6 +579,14 @@
      */
     void Remove(Ptr<Ipv6ExtensionRouting> extensionRouting);
 
+    /**
+     * Assigns stream numbers to the registered extensions of this IPv6 routing demux object
+     *
+     * @param stream the first stream number to assign
+     * @returns the number of assigned streams
+     */
+    int64_t AssignStreams(int64_t stream);
+
   protected:
     /**
      * @brief Dispose this object.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-l3-protocol.cc ns-3.47/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.46/src/internet/model/ipv6-l3-protocol.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-l3-protocol.cc	2026-02-16 16:08:49.616230000 -0800
@@ -1428,7 +1428,6 @@
     Ptr<IpL4Protocol> protocol = nullptr;
     Ptr<Ipv6ExtensionDemux> ipv6ExtensionDemux = m_node->GetObject<Ipv6ExtensionDemux>();
     Ptr<Ipv6Extension> ipv6Extension = nullptr;
-    Ipv6Address src = ip.GetSource();
     Ipv6Address dst = ip.GetDestination();
     uint8_t nextHeader = ip.GetNextHeader();
     uint8_t nextHeaderPosition = 0;
@@ -1515,7 +1514,6 @@
             else
             {
                 p->RemoveAtStart(nextHeaderPosition);
-                /* protocol->Receive (p, src, dst, incomingInterface); */
 
                 // Options have been processed, and the packet is good.
                 // We need to adjust the IP header fields
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-list-routing.cc ns-3.47/src/internet/model/ipv6-list-routing.cc
--- ns-3.46/src/internet/model/ipv6-list-routing.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-list-routing.cc	2026-02-16 16:08:49.616230000 -0800
@@ -102,7 +102,6 @@
     NS_ASSERT(m_ipv6);
     // Check if input device supports IP
     NS_ASSERT(m_ipv6->GetInterfaceForDevice(idev) >= 0);
-    Ipv6Address dst = header.GetDestination();
 
     // Check if input device supports IP forwarding
     uint32_t iif = m_ipv6->GetInterfaceForDevice(idev);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-routing-table-entry.cc ns-3.47/src/internet/model/ipv6-routing-table-entry.cc
--- ns-3.46/src/internet/model/ipv6-routing-table-entry.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-routing-table-entry.cc	2026-02-16 16:08:49.617230000 -0800
@@ -263,6 +263,13 @@
     return os;
 }
 
+bool
+operator==(const Ipv6RoutingTableEntry a, const Ipv6RoutingTableEntry b)
+{
+    return (a.GetDest() == b.GetDest() && a.GetDestNetworkPrefix() == b.GetDestNetworkPrefix() &&
+            a.GetGateway() == b.GetGateway() && a.GetInterface() == b.GetInterface());
+}
+
 Ipv6MulticastRoutingTableEntry::Ipv6MulticastRoutingTableEntry()
 {
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-routing-table-entry.h ns-3.47/src/internet/model/ipv6-routing-table-entry.h
--- ns-3.46/src/internet/model/ipv6-routing-table-entry.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-routing-table-entry.h	2026-02-16 16:08:49.617230000 -0800
@@ -280,6 +280,15 @@
 std::ostream& operator<<(std::ostream& os, const Ipv6RoutingTableEntry& route);
 
 /**
+ * @brief Equality operator.
+ *
+ * @param a lhs
+ * @param b rhs
+ * @returns true if operands are equal, false otherwise
+ */
+bool operator==(const Ipv6RoutingTableEntry a, const Ipv6RoutingTableEntry b);
+
+/**
  * @ingroup ipv6Routing
  *
  * @brief A record of an IPv6 multicast route.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ipv6-static-routing.cc ns-3.47/src/internet/model/ipv6-static-routing.cc
--- ns-3.46/src/internet/model/ipv6-static-routing.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ipv6-static-routing.cc	2026-02-16 16:08:49.617230000 -0800
@@ -254,8 +254,8 @@
 {
     NS_LOG_FUNCTION(this << outputInterface);
     auto route = new Ipv6RoutingTableEntry();
-    Ipv6Address network = Ipv6Address("ff00::"); /* RFC 3513 */
-    Ipv6Prefix networkMask = Ipv6Prefix(8);
+    auto network = Ipv6Address("ff00::"); /* RFC 3513 */
+    auto networkMask = Ipv6Prefix(8);
     *route = Ipv6RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, outputInterface);
     m_networkRoutes.emplace_back(route, 0);
 }
@@ -559,7 +559,6 @@
         uint32_t metric = it->second;
         Ipv6Prefix mask = j->GetDestNetworkPrefix();
         uint16_t maskLen = mask.GetPrefixLength();
-        Ipv6Address entry = j->GetDestNetwork();
 
         if (maskLen)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/ripng.cc ns-3.47/src/internet/model/ripng.cc
--- ns-3.46/src/internet/model/ripng.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/ripng.cc	2026-02-16 16:08:49.618229900 -0800
@@ -1046,7 +1046,7 @@
 
     for (auto iter = rtes.begin(); iter != rtes.end(); iter++)
     {
-        Ipv6Prefix rtePrefix = Ipv6Prefix(iter->GetPrefixLen());
+        auto rtePrefix = Ipv6Prefix(iter->GetPrefixLen());
         Ipv6Address rteAddr = iter->GetPrefix().CombinePrefix(rtePrefix);
 
         NS_LOG_LOGIC("Processing RTE " << *iter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-congestion-ops.cc ns-3.47/src/internet/model/tcp-congestion-ops.cc
--- ns-3.46/src/internet/model/tcp-congestion-ops.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-congestion-ops.cc	2026-02-16 16:08:49.619230000 -0800
@@ -86,7 +86,17 @@
     static TypeId tid = TypeId("ns3::TcpNewReno")
                             .SetParent<TcpCongestionOps>()
                             .SetGroupName("Internet")
-                            .AddConstructor<TcpNewReno>();
+                            .AddConstructor<TcpNewReno>()
+                            .AddAttribute("BetaLoss",
+                                          "Beta for multiplicative decrease",
+                                          DoubleValue(0.5),
+                                          MakeDoubleAccessor(&TcpNewReno::m_betaLoss),
+                                          MakeDoubleChecker<double>(0.0, 1.0))
+                            .AddAttribute("BetaEcn",
+                                          "Beta for multiplicative decrease for ABE",
+                                          DoubleValue(0.7), // According to RFC 8511 (ABE)
+                                          MakeDoubleAccessor(&TcpNewReno::m_betaEcn),
+                                          MakeDoubleChecker<double>(0.0, 1.0));
     return tid;
 }
 
@@ -234,7 +244,13 @@
 {
     NS_LOG_FUNCTION(this << state << bytesInFlight);
 
-    return std::max(2 * state->m_segmentSize, bytesInFlight / 2);
+    if (state->m_abeEnabled && state->m_ecnState == TcpSocketState::ECN_ECE_RCVD)
+    {
+        return std::max<uint32_t>(2 * state->m_segmentSize,
+                                  bytesInFlight * m_betaEcn); // According to RFC 8511 (ABE)
+    }
+
+    return std::max<uint32_t>(2 * state->m_segmentSize, bytesInFlight * m_betaLoss);
 }
 
 Ptr<TcpCongestionOps>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-congestion-ops.h ns-3.47/src/internet/model/tcp-congestion-ops.h
--- ns-3.46/src/internet/model/tcp-congestion-ops.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-congestion-ops.h	2026-02-16 16:08:49.619230000 -0800
@@ -234,6 +234,10 @@
   protected:
     virtual uint32_t SlowStart(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
     virtual void CongestionAvoidance(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+
+  private:
+    double m_betaLoss{0}; //!< Beta for New-Reno multiplicative decrease
+    double m_betaEcn{0};  //!< Beta for New-Reno multiplicative decrease with ABE
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-cubic.cc ns-3.47/src/internet/model/tcp-cubic.cc
--- ns-3.46/src/internet/model/tcp-cubic.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-cubic.cc	2026-02-16 16:08:49.619230000 -0800
@@ -43,7 +43,12 @@
                           "Beta for multiplicative decrease",
                           DoubleValue(0.7),
                           MakeDoubleAccessor(&TcpCubic::m_beta),
-                          MakeDoubleChecker<double>(0.0))
+                          MakeDoubleChecker<double>(0.0, 1.0))
+            .AddAttribute("BetaEcn",
+                          "Beta for multiplicative decrease for ABE",
+                          DoubleValue(0.85), // According to RFC 8511 (ABE)
+                          MakeDoubleAccessor(&TcpCubic::m_betaEcn),
+                          MakeDoubleChecker<double>(0.0, 1.0))
             .AddAttribute("HyStart",
                           "Enable (true) or disable (false) hybrid slow start algorithm",
                           BooleanValue(true),
@@ -129,6 +134,7 @@
     : TcpCongestionOps(sock),
       m_fastConvergence(sock.m_fastConvergence),
       m_beta(sock.m_beta),
+      m_betaEcn(sock.m_betaEcn),
       m_hystart(sock.m_hystart),
       m_hystartDetect(sock.m_hystartDetect),
       m_hystartLowWindow(sock.m_hystartLowWindow),
@@ -467,8 +473,16 @@
 
     m_epochStart = Time::Min(); // end of epoch
 
-    /* Formula taken from the Linux kernel */
-    uint32_t ssThresh = std::max(static_cast<uint32_t>(segCwnd * m_beta), 2U) * tcb->m_segmentSize;
+    uint32_t ssThresh;
+    if (tcb->m_abeEnabled && tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD)
+    {
+        ssThresh = std::max(static_cast<uint32_t>(segCwnd * m_betaEcn), 2U) *
+                   tcb->m_segmentSize; // According to RFC 8511 (ABE)
+    }
+    else
+    { /* Formula taken from the Linux kernel */
+        ssThresh = std::max(static_cast<uint32_t>(segCwnd * m_beta), 2U) * tcb->m_segmentSize;
+    }
 
     NS_LOG_DEBUG("SsThresh = " << ssThresh);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-cubic.h ns-3.47/src/internet/model/tcp-cubic.h
--- ns-3.46/src/internet/model/tcp-cubic.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-cubic.h	2026-02-16 16:08:49.619230000 -0800
@@ -93,10 +93,10 @@
     void Init(Ptr<TcpSocketState> tcb) override;
 
   private:
-    bool m_fastConvergence; //!< Enable or disable fast convergence algorithm
-    bool m_tcpFriendliness; //!< Enable or disable TCP-friendliness heuristic
-    double m_beta;          //!< Beta for cubic multiplicative increase
-
+    bool m_fastConvergence;                //!< Enable or disable fast convergence algorithm
+    bool m_tcpFriendliness;                //!< Enable or disable TCP-friendliness heuristic
+    double m_beta;                         //!< Beta for cubic multiplicative decrease
+    double m_betaEcn;                      //!< Beta for cubic multiplicative decrease with ABE
     bool m_hystart;                        //!< Enable or disable HyStart algorithm
     HybridSSDetectionMode m_hystartDetect; //!< Detect way for HyStart algorithm
     uint32_t m_hystartLowWindow;           //!< Lower bound cWnd for hybrid slow start (segments)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-illinois.h ns-3.47/src/internet/model/tcp-illinois.h
--- ns-3.46/src/internet/model/tcp-illinois.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-illinois.h	2026-02-16 16:08:49.619230000 -0800
@@ -156,7 +156,6 @@
      */
     void PktsAcked(Ptr<TcpSocketState> tcb, uint32_t segmentsAcked, const Time& rtt) override;
 
-  protected:
   private:
     /**
      * @brief Recalculate alpha and beta every RTT
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-ledbat.cc ns-3.47/src/internet/model/tcp-ledbat.cc
--- ns-3.46/src/internet/model/tcp-ledbat.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-ledbat.cc	2026-02-16 16:08:49.619230000 -0800
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Ankit Deepak <adadeepak8@gmail.com>
+ * Modified by: S B L Prateek <sblprateek@gmail.com>
  *
  */
 
@@ -37,17 +38,17 @@
                           "Number of Base delay samples",
                           UintegerValue(10),
                           MakeUintegerAccessor(&TcpLedbat::m_baseHistoLen),
-                          MakeUintegerChecker<uint32_t>())
+                          MakeUintegerChecker<uint32_t>(1))
             .AddAttribute("NoiseFilterLen",
                           "Number of Current delay samples",
                           UintegerValue(4),
                           MakeUintegerAccessor(&TcpLedbat::m_noiseFilterLen),
-                          MakeUintegerChecker<uint32_t>())
+                          MakeUintegerChecker<uint32_t>(1))
             .AddAttribute("Gain",
                           "Offset Gain",
                           DoubleValue(1.0),
                           MakeDoubleAccessor(&TcpLedbat::m_gain),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<double>(1e-6))
             .AddAttribute("SSParam",
                           "Possibility of Slow Start",
                           EnumValue(DO_SLOWSTART),
@@ -57,7 +58,12 @@
                           "Minimum cWnd for Ledbat",
                           UintegerValue(2),
                           MakeUintegerAccessor(&TcpLedbat::m_minCwnd),
-                          MakeUintegerChecker<uint32_t>());
+                          MakeUintegerChecker<uint32_t>(1))
+            .AddAttribute("AllowedIncrease",
+                          "Allowed Increase",
+                          DoubleValue(1.0),
+                          MakeDoubleAccessor(&TcpLedbat::m_allowedIncrease),
+                          MakeDoubleChecker<double>(1e-6));
     return tid;
 }
 
@@ -80,17 +86,11 @@
     : TcpNewReno()
 {
     NS_LOG_FUNCTION(this);
-    m_target = MilliSeconds(100);
-    m_gain = 1;
-    m_doSs = DO_SLOWSTART;
-    m_baseHistoLen = 10;
-    m_noiseFilterLen = 4;
     InitCircBuf(m_baseHistory);
     InitCircBuf(m_noiseFilter);
-    m_lastRollover = 0;
+    m_lastRollover = Seconds(0);
     m_sndCwndCnt = 0;
     m_flag = LEDBAT_CAN_SS;
-    m_minCwnd = 2;
 }
 
 void
@@ -116,6 +116,7 @@
     m_sndCwndCnt = sock.m_sndCwndCnt;
     m_flag = sock.m_flag;
     m_minCwnd = sock.m_minCwnd;
+    m_allowedIncrease = sock.m_allowedIncrease;
 }
 
 TcpLedbat::~TcpLedbat()
@@ -193,31 +194,35 @@
             segmentsAcked); // letting it fall to TCP behaviour if no timestamps
         return;
     }
-    int64_t queue_delay;
+    uint32_t queueDelay;
     double offset;
-    uint32_t cwnd = (tcb->m_cWnd.Get());
-    uint32_t max_cwnd;
-    uint64_t current_delay = CurrentDelay(&TcpLedbat::MinCircBuf);
-    uint64_t base_delay = BaseDelay();
+    uint32_t cwnd = tcb->m_cWnd.Get();
+    uint32_t maxCwnd;
+    uint32_t currentDelay = CurrentDelay(&TcpLedbat::MinCircBuf);
+    uint32_t baseDelay = BaseDelay();
 
-    if (current_delay > base_delay)
+    if (currentDelay > baseDelay)
     {
-        queue_delay = static_cast<int64_t>(current_delay - base_delay);
-        offset = m_target.GetMilliSeconds() - queue_delay;
+        queueDelay = currentDelay - baseDelay;
+        offset = m_target.GetMilliSeconds() - queueDelay;
     }
     else
     {
-        queue_delay = static_cast<int64_t>(base_delay - current_delay);
-        offset = m_target.GetMilliSeconds() + queue_delay;
+        queueDelay = baseDelay - currentDelay;
+        offset = m_target.GetMilliSeconds() + queueDelay;
     }
     offset *= m_gain;
-    m_sndCwndCnt = static_cast<int32_t>(offset * segmentsAcked * tcb->m_segmentSize);
-    double inc = (m_sndCwndCnt * 1.0) / (m_target.GetMilliSeconds() * tcb->m_cWnd.Get());
+    m_sndCwndCnt = offset * segmentsAcked * tcb->m_segmentSize;
+    double inc = m_sndCwndCnt / (m_target.GetMilliSeconds() * tcb->m_cWnd.Get());
     cwnd += (inc * tcb->m_segmentSize);
 
-    max_cwnd = static_cast<uint32_t>(tcb->m_highTxMark.Get() - tcb->m_lastAckedSeq) +
-               segmentsAcked * tcb->m_segmentSize;
-    cwnd = std::min(cwnd, max_cwnd);
+    // Since m_bytesInFlight reflects the state after processing the current ACK,
+    // adding segmentsAcked * m_segmentSize reconstructs the flight size before this
+    // ACK arrived, as required by the RFC definition of flight size.
+    uint32_t flightSizeBeforeAck =
+        tcb->m_bytesInFlight.Get() + (segmentsAcked * tcb->m_segmentSize);
+    maxCwnd = flightSizeBeforeAck + static_cast<uint32_t>(m_allowedIncrease * tcb->m_segmentSize);
+    cwnd = std::min(cwnd, maxCwnd);
     cwnd = std::max(cwnd, m_minCwnd * tcb->m_segmentSize);
     tcb->m_cWnd = cwnd;
 
@@ -241,21 +246,15 @@
     cb.buffer.push_back(owd);
     if (cb.buffer[cb.min] > owd)
     {
-        cb.min = static_cast<uint32_t>(cb.buffer.size() - 1);
+        cb.min = cb.buffer.size() - 1;
     }
     if (cb.buffer.size() >= maxlen)
     {
         NS_LOG_LOGIC("Queue full" << maxlen);
         cb.buffer.erase(cb.buffer.begin());
-        cb.min = 0;
+        auto bufferStart = cb.buffer.begin();
+        cb.min = std::distance(bufferStart, std::min_element(bufferStart, cb.buffer.end()));
         NS_LOG_LOGIC("Current min element" << cb.buffer[cb.min]);
-        for (uint32_t i = 1; i < maxlen - 1; i++)
-        {
-            if (cb.buffer[i] < cb.buffer[cb.min])
-            {
-                cb.min = i;
-            }
-        }
     }
 }
 
@@ -268,16 +267,16 @@
         AddDelay(m_baseHistory, owd, m_baseHistoLen);
         return;
     }
-    uint64_t timestamp = static_cast<uint64_t>(Simulator::Now().GetSeconds());
+    Time timestamp = Simulator::Now();
 
-    if (timestamp - m_lastRollover > 60)
+    if ((timestamp - m_lastRollover) > Seconds(60))
     {
         m_lastRollover = timestamp;
         AddDelay(m_baseHistory, owd, m_baseHistoLen);
     }
     else
     {
-        auto last = static_cast<uint32_t>(m_baseHistory.buffer.size() - 1);
+        size_t last = m_baseHistory.buffer.size() - 1;
         if (owd < m_baseHistory.buffer[last])
         {
             m_baseHistory.buffer[last] = owd;
@@ -301,12 +300,11 @@
     {
         m_flag |= LEDBAT_VALID_OWD;
     }
-    if (rtt.IsPositive())
+    if (rtt.IsPositive() && tcb->m_rcvTimestampValue >= tcb->m_rcvTimestampEchoReply)
     {
-        AddDelay(m_noiseFilter,
-                 tcb->m_rcvTimestampValue - tcb->m_rcvTimestampEchoReply,
-                 m_noiseFilterLen);
-        UpdateBaseDelay(tcb->m_rcvTimestampValue - tcb->m_rcvTimestampEchoReply);
+        uint32_t owd = tcb->m_rcvTimestampValue - tcb->m_rcvTimestampEchoReply;
+        AddDelay(m_noiseFilter, owd, m_noiseFilterLen);
+        UpdateBaseDelay(owd);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-ledbat.h ns-3.47/src/internet/model/tcp-ledbat.h
--- ns-3.46/src/internet/model/tcp-ledbat.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-ledbat.h	2026-02-16 16:08:49.619230000 -0800
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Ankit Deepak <adadeepak8@gmail.com>
+ * Modified by: S B L Prateek <sblprateek@gmail.com>
  *
  */
 
@@ -120,7 +121,7 @@
     struct OwdCircBuf
     {
         std::vector<uint32_t> buffer; //!< Vector to store the delay
-        uint32_t min;                 //!< The index of minimum value
+        size_t min;                   //!< The index of minimum value
     };
 
     /**
@@ -177,12 +178,13 @@
     SlowStartType m_doSs;      //!< Permissible Slow Start State
     uint32_t m_baseHistoLen;   //!< Length of base delay history buffer
     uint32_t m_noiseFilterLen; //!< Length of current delay buffer
-    uint64_t m_lastRollover;   //!< Timestamp of last added delay
-    int32_t m_sndCwndCnt;      //!< The congestion window addition parameter
+    Time m_lastRollover;       //!< Timestamp of last added delay
+    double m_sndCwndCnt;       //!< The congestion window addition parameter
     OwdCircBuf m_baseHistory;  //!< Buffer to store the base delay
     OwdCircBuf m_noiseFilter;  //!< Buffer to store the current delay
     uint32_t m_flag;           //!< LEDBAT Flag
     uint32_t m_minCwnd;        //!< Minimum cWnd value mentioned in RFC 6817
+    double m_allowedIncrease;  //!< ALLOWED INCREASE value mentioned in RFC 6817
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-linux-reno.cc ns-3.47/src/internet/model/tcp-linux-reno.cc
--- ns-3.46/src/internet/model/tcp-linux-reno.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-linux-reno.cc	2026-02-16 16:08:49.620230000 -0800
@@ -25,7 +25,18 @@
     static TypeId tid = TypeId("ns3::TcpLinuxReno")
                             .SetParent<TcpCongestionOps>()
                             .SetGroupName("Internet")
-                            .AddConstructor<TcpLinuxReno>();
+                            .AddConstructor<TcpLinuxReno>()
+                            .AddAttribute("BetaLoss",
+                                          "Beta for multiplicative decrease",
+                                          DoubleValue(0.5),
+                                          MakeDoubleAccessor(&TcpLinuxReno::m_betaLoss),
+                                          MakeDoubleChecker<double>(0.0, 1.0))
+                            .AddAttribute("BetaEcn",
+                                          "Beta for multiplicative decrease for ABE",
+                                          DoubleValue(0.7), // According to RFC 8511 (ABE)
+                                          MakeDoubleAccessor(&TcpLinuxReno::m_betaEcn),
+                                          MakeDoubleChecker<double>(0.0, 1.0));
+
     return tid;
 }
 
@@ -136,8 +147,13 @@
 {
     NS_LOG_FUNCTION(this << state << bytesInFlight);
 
-    // In Linux, it is written as:  return max(tp->snd_cwnd >> 1U, 2U);
-    return std::max<uint32_t>(2 * state->m_segmentSize, state->m_cWnd / 2);
+    if (state->m_abeEnabled && state->m_ecnState == TcpSocketState::ECN_ECE_RCVD)
+    {
+        return std::max<uint32_t>(2 * state->m_segmentSize,
+                                  state->m_cWnd * m_betaEcn); // According to RFC 8511 (ABE)
+    }
+
+    return std::max<uint32_t>(2 * state->m_segmentSize, state->m_cWnd * m_betaLoss);
 }
 
 Ptr<TcpCongestionOps>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-linux-reno.h ns-3.47/src/internet/model/tcp-linux-reno.h
--- ns-3.46/src/internet/model/tcp-linux-reno.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-linux-reno.h	2026-02-16 16:08:49.620230000 -0800
@@ -84,6 +84,9 @@
     // tcp_reno_cong_avoid()
     bool m_suppressIncreaseIfCwndLimited{
         true}; //!< Suppress window increase if TCP is not cwnd limited
+
+    double m_betaLoss; //!< Beta for Linux-Reno multiplicative decrease
+    double m_betaEcn;  //!< Beta for Linux-Reno multiplicative decrease with ABE
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/tcp-option.h ns-3.47/src/internet/model/tcp-option.h
--- ns-3.46/src/internet/model/tcp-option.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/tcp-option.h	2026-02-16 16:08:49.620230000 -0800
@@ -71,7 +71,7 @@
     virtual uint32_t Deserialize(Buffer::Iterator start) = 0;
 
     /**
-     * @brief Get the `kind' (as in \RFC{793}) of this option
+     * @brief Get the `kind` (as in \RFC{793}) of this option
      * @return the Option Kind
      */
     virtual uint8_t GetKind() const = 0;
